'use strict';

exports.__esModule = true;
exports.FormFieldErrors = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _formContext = require('./form-context');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FormFieldErrorsComponent = function (_React$Component) {
  (0, _inherits3.default)(FormFieldErrorsComponent, _React$Component);

  function FormFieldErrorsComponent() {
    (0, _classCallCheck3.default)(this, FormFieldErrorsComponent);
    return (0, _possibleConstructorReturn3.default)(this, _React$Component.apply(this, arguments));
  }

  FormFieldErrorsComponent.prototype.render = function render() {
    var _props = this.props,
        field = _props.field,
        formError = _props.formError,
        other = (0, _objectWithoutProperties3.default)(_props, ['field', 'formError']);

    return field.dirty ? _react2.default.createElement(
      'div',
      other,
      field.errors.map(function (error, index) {
        return _react2.default.createElement(
          'div',
          { key: index },
          error
        );
      }),
      field.asyncErrors.map(function (error, index) {
        return _react2.default.createElement(
          'div',
          { key: index },
          error
        );
      }),
      formError
    ) : null;
  };

  return FormFieldErrorsComponent;
}(_react2.default.Component);

var FormFieldErrors = function (_React$Component2) {
  (0, _inherits3.default)(FormFieldErrors, _React$Component2);

  function FormFieldErrors(props, context) {
    (0, _classCallCheck3.default)(this, FormFieldErrors);

    var _this2 = (0, _possibleConstructorReturn3.default)(this, _React$Component2.call(this, props, context));

    _this2.formError = false;
    return _this2;
  }

  FormFieldErrors.prototype.componentDidMount = function componentDidMount() {
    var _this3 = this;

    this.fieldSubscriberId = this.context.form.fields.subscribe(function () {
      _this3.forceUpdate();
    }, this.props.name);
    this.formFieldSubscriberId = this.context.form.validators.subscribe(function (error) {
      if (_this3.formError !== error) {
        _this3.formError = error;
        _this3.forceUpdate();
      }
    }, this.props.name);
  };

  FormFieldErrors.prototype.componentWillUnmount = function componentWillUnmount() {
    this.context.form.fields.removeSubscriber(this.fieldSubscriberId);
    this.context.form.validators.removeSubscriber(this.formFieldSubscriberId);
    this.fieldSubscriberId = null;
    this.formFieldSubscriberId = null;
  };

  FormFieldErrors.prototype.render = function render() {
    var _props2 = this.props,
        name = _props2.name,
        component = _props2.component,
        other = (0, _objectWithoutProperties3.default)(_props2, ['name', 'component']);

    var field = this.context.form.fields.getFieldOptions(name);
    var element = _react2.default.createElement(component || FormFieldErrorsComponent, (0, _extends3.default)({
      field: field,
      formError: this.formError
    }, other));
    return field ? element : null;
  };

  return FormFieldErrors;
}(_react2.default.Component);

FormFieldErrors.propTypes = {
  name: _react2.default.PropTypes.string.isRequired,
  component: _react2.default.PropTypes.func
};

FormFieldErrors.contextTypes = {
  form: _react2.default.PropTypes.instanceOf(_formContext.FormContext).isRequired
};

exports.FormFieldErrors = FormFieldErrors;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(FormFieldErrorsComponent, 'FormFieldErrorsComponent', 'E:/Projects/React/git/vb-react-form/src/form-field-errors.js');

  __REACT_HOT_LOADER__.register(FormFieldErrors, 'FormFieldErrors', 'E:/Projects/React/git/vb-react-form/src/form-field-errors.js');
}();

;